#!/bin/sh
#
# This file is part of Rheolef.
#
# Copyright (C) 2000-2009 Pierre Saramito 
#
# Rheolef is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Rheolef is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rheolef; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# -------------------------------------------------------------------------
PACKAGE=@PACKAGE@
VERSION=@VERSION@
in_srcdir=true
top_srcdir=../..

#Prog:bamg2geo
#NAME: @code{bamg2geo} - convert bamg mesh in geo format
#@cindex mesh
#@pindex bamg2geo
#@pindex geo
#@fiindex @file{.bamg} bamg mesh
#@fiindex @file{.dmn} domain names
#@fiindex @file{.geo} mesh
#@toindex @code{bamg}
#SYNOPSIS:
#@example
#  bamg2geo @var{options} @var{input}[.bamg] @var{input}[.dmn]
#  bamg2geo @var{options} @var{input}[.bamg] -Cl @var{domlabel}
#  bamg2geo @var{options} @var{input}[.bamg] @{-dom @var{domname}@}*
#@end example
#
#DESCRIPTION:
#Convert a bamg @file{.bamg} into @file{.geo} one.
#The output goes to standart output.
#The @file{.dmn} file specifies the domain names,
#since @code{bamg} mesh generator uses numbers as domain labels.
#
#EXAMPLE:
#@example
#  bamg -g toto.bamgcad -o toto.bamg
#  bamg2geo toto.bamg toto.dmn > toto.geo
#@end example
#
#BAMG CAD FILE:
#This file describe the boundary of the mesh geometry.
#A basic example writes (See bamg documentation for more);
#@example
#  MeshVersionFormatted
#    0
#  Dimension
#    2
#  Vertices
#    4
#    0  0     1
#    1  0     2
#    1  1     3
#    0  1     4
#  Edges
#    4
#    1  2     101
#    2  3     102
#    3  4     103
#    4  1     104
#  hVertices
#    0.1 0.1 0.1 0.1
#@end example
#DOMAIN NAME FILE:
#This auxilliary @file{.dmn} file defines the boundary domain names
#as used by Rheolef, since @code{bamg} uses numeric
#labels for domains.
#@example
#  EdgeDomainNames
#    4
#    bottom
#    right
#    top
#    left
#@end example
#The domain name file can also specify additional vertices domain:
#@example
#  EdgeDomainNames
#    4
#    bottom
#    right
#    top
#    left
#  VerticeDomainNames
#    4
#    left_bottom
#    right_bottom
#    right_top
#    left_top
#@end example
#Vertice domain names are usefull for some special boundary conditions.
#OPTIONS:
#@table @code
#  @item -upgrade
#  @itemx -noupgrade
#	Default is to output a version 2 @file{.geo} file format. @xref{geo command}.	
#	With the @code{-noupgrade}, a version 1 file format is assumed.
#  @item -cartesian
#  @itemx -rz
#  @itemx -zr
#	Specifies the coordinate system.
#  @item -dom @var{dom1} ... -dom @var{domN}
#@end table
#End:

#============================================================
# Usage
#============================================================

PROG=`expr $0 : '.*/\(.*\)' \| $0`

USAGE="usage: $PROG [-[no]upgrade] [-catresian|-rz|-rz] input[.bamg] input[.dmn]"

#============================================================
# Arguments
#============================================================

if test $# = 0; then
    echo $USAGE 1>&2; exit 0
fi

tmpdir=${TMPDIR-"/tmp"}
do_dom=false
set_dom=false
upgrade="-upgrade"
bamg_file=""
dom_list=""
geobin="geo"
sys_coord_flag=""
while test $# -ne 0; do
    case $1 in
	-help)        echo $USAGE 1>&2; exit 0;;
	-noupgrade)   upgrade="";;
	-upgrade)     upgrade="-upgrade";;
	-cartesian)   ;;
	-rz|-zr)      sys_coord_flag="$1";;
	-dom)         do_dom=true; dom_list="${dom_list} $2"; shift;;
      	*.bamg)       bamg_file=$1;;
      	*.dmn)        dmn_file=$1;;
      	-bamg)        if test x"$2" = x""; then
			echo "$PROG: no argument to -bamg option found." 1>&2
		        echo $USAGE 1>&2; exit 1
                      fi
      		      bamg_file=$2
		      shift
		      ;;
      	-dmn)        if test x"$2" = x""; then
			echo "$PROG: no argument to -dmn option found." 1>&2
		        echo $USAGE 1>&2; exit 1
                      fi
      		      dmn_file=$2
		      shift
		      ;;
	-geobin)      if test x"$2" = x""; then
			echo "$PROG: no argument to -geobin option found." 1>&2
			echo $USAGE 1>&2; exit 1
		      fi
                      geobin=$2
		      shift
		      ;;
	*) 	      
		      echo "$PROG: invalid $1 option." 1>&2
		      echo $USAGE 1>&2; exit 1
		      ;;
    esac
    shift
done

if test x"${bamg_file}" = x""; then
   echo $USAGE 1>&2
   exit 1
fi

#============================================================
# buid the `.dmn' domain name file
#============================================================

if test x"${dom_list}" != x""; then
    dmn_file=${TMPDIR}/bamg2geo-$$.dmn
    /bin/rm -f ${dmn_file}
    echo "DomainNames" > ${dmn_file}
    n=0
    for dom in ${dom_list}; do
       n=`expr ${n} + 1`
    done
    echo ${n} >> ${dmn_file}
    for dom in ${dom_list}; do
       echo $dom >> ${dmn_file}
    done
    tmpdmn_file=${dmn_file}
elif test x"${dmn_file}" = x""; then
    echo "$PROG: undefined domain names" 1>&2
    echo $USAGE 1>&2; exit 1
elif test ! -f ${dmn_file}; then
    echo "$PROG: file \"${dmn_file}\" not found" 1>&2
    echo $USAGE 1>&2; exit 1
fi
#============================================================
# buid the `.geo' mesh file
#============================================================
new_format=`rheolef-config --have-new-code 2>/dev/null`
if "$new_format" = true; then
  options="$sys_coord_flag -if bamg -add-boundary"
else
  options="-name toto -input-bamg -upgrade"
fi
cat ${bamg_file} ${dmn_file} | ${geobin} ${options} -geo -noverbose -check -
status=$?
if test $status -ne 0; then
    echo "$PROG(fatal): ${geobin} exit with $status status." 1>&2
    exit $status
fi

